/*
 * Hydrogen
 * Copyright(c) 2002-2003 by Alex >Comix< Cominu [comix@users.sourceforge.net]
 *
 * http://hydrogen.sourceforge.net
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY, without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 *
 * $Id: GenericDriver.h,v 1.9 2003/08/09 07:15:27 comix Exp $
 *
 */
#ifndef GENERIC_AUDIO_DRIVER_H
#define GENERIC_AUDIO_DRIVER_H

#include "Object.h"
#include "Sample.h"

//----------------------------------------------------------------------------
/**
 * GenericDriver is the base abstract class for audio device drivers.
 */
class GenericDriver : public Object{
	private:
	public:
		virtual int init(uint nBufferSize) = 0;
		virtual int connect() = 0;
		virtual void disconnect() = 0;
//		virtual void write(float* buffer_L, float* buffer_R, unsigned int bufferSize) = 0;
//		virtual void writeTrack(unsigned int chan, float* buffer_L, float* buffer_R, unsigned int bufferSize) = 0;
		virtual uint getBufferSize() = 0;
		virtual uint getSampleRate() = 0;
		virtual float* getOut_L() = 0;
		virtual float* getOut_R() = 0;

};

#endif

