/*
 * Hydrogen
 * Copyright(c) 2002-2003 by Alex >Comix< Cominu [comix@users.sourceforge.net]
 *
 * http://hydrogen.sourceforge.net
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY, without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 *
 * $Id: NullDriver.h,v 1.4 2003/08/28 12:48:38 comix Exp $
 *
 */


#ifndef NULL_AUDIO_DRIVER_H
#define NULL_AUDIO_DRIVER_H

#include "GenericDriver.h"
#include <inttypes.h>

typedef int  (*audioProcessCallback)(uint32_t, void *);

//----------------------------------------------------------------------------
/**
 * Null Audio Driver
 */
class NullDriver : public GenericDriver {
	public:
		virtual string getClassName() {	return "NullDriver";	}

		/** Constructor */
		NullDriver(audioProcessCallback processCallback);

		/** Destructor */
		~NullDriver();

		int init(uint nBufferSize);
		int connect();
		void disconnect();
//		void write(float* buffer_L, float* buffer_R, unsigned int bufferSize);
//		void writeTrack(unsigned int chan, float* buffer_L, float* buffer_R, unsigned int bufferSize) {};
		uint getBufferSize();
		uint getSampleRate();

		float* getOut_L();
		float* getOut_R();

};

#endif

