/*
 * Hydrogen
 * Copyright(c) 2002-2003 by Alex >Comix< Cominu [comix@users.sourceforge.net]
 *
 * http://hydrogen.sourceforge.net
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY, without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 *
 * $Id: OssDriver.h,v 1.17 2003/08/28 12:48:38 comix Exp $
 *
 */


#ifndef OSS_AUDIO_DRIVER_H
#define OSS_AUDIO_DRIVER_H

#include "config.h"

// check if OSS support is enabled
#ifdef OSS_SUPPORT


#ifdef __NetBSD__
	#include <soundcard.h>
#else
	#include <sys/soundcard.h>
#endif
#include <sys/ioctl.h>
#include <stdio.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <fcntl.h>
#include <iostream>
#include <unistd.h>
#include <inttypes.h>

using std::cout;
using std::endl;

#include "GenericDriver.h"
#include "PreferencesMng.h"

/*
#ifdef __NetBSD__
	#define AUDIO_DEVICE "/dev/audio"
#else
	#define AUDIO_DEVICE "/dev/dsp"
#endif
*/
typedef int  (*audioProcessCallback)(uint32_t, void *);

//----------------------------------------------------------------------------
/**
 * OSS Audio Driver
 */
class OssDriver : public GenericDriver {
	public:
		virtual string getClassName() {	return "OssDriver";	}

		/** Constructor */
		OssDriver(audioProcessCallback processCallback);

		/** Destructor */
		~OssDriver();

		int init(uint bufferSize);
		int connect();

		void disconnect();

		void write();
//		void writeTrack(unsigned int chan, float* buffer_L,  float* buffer_R, unsigned int bufferSize) {};
		uint getBufferSize();
		uint getSampleRate();
		float* getOut_L();
		float* getOut_R();

	private:
		/** file descriptor, for writing to /dev/dsp */
		int fd;

		short* audioBuffer;
		float* out_L;
		float* out_R;

		audioProcessCallback processCallback;
		int log2(int n);

};


#endif // OSS support

#endif
